{$R-}
(*
SetDirectory - To place Hypertalk variables onto the clipboard
Jon Pugh 1987
All Rights Reserved.

pascal SetDirectory.p
link -o HyperCommands -rt XCMD=0 -c 'RSED' -t 'rsrc' -m ENTRYPOINT 
	-sn Main=SetDirectory SetDirectory.p.o "{Libraries}"Interface.o

*)

{$S SetDirectory } 	{ Segment name must be the same as the command name. }

UNIT DummyUnit;

INTERFACE

USES
	MemTypes, QuickDraw, OSIntf, ToolIntf, PackIntf, HyperXCmd;

PROCEDURE EntryPoint (paramPtr : XCmdPtr);

IMPLEMENTATION

TYPE
	Str31 = String[31];

PROCEDURE SetDirectory (paramPtr : XCmdPtr); FORWARD;

PROCEDURE ENTRYPOINT(paramPtr: XCmdPtr);
BEGIN
SetDirectory(paramPtr);
END;	{ EntryPoint }

PROCEDURE SetDirectory;
CONST
	CurDirStoreLoc = $398;
VAR
	error	: Boolean;
	junk	: Str255;
	myCPB	: CInfoPBRec;
	err		: OSErr;
	CurDirStore	: ^LongInt;
{$I XCmdGlue.inc }

BEGIN
error := False;
CurDirStore := Pointer(CurDirStoreLoc);
WITH paramPtr^ DO
	BEGIN
	{ only param is pathname (or partial) to set SFGetFile and SFPutFile to }
	IF paramCount = 0 THEN
		BEGIN
		Error := true;
		returnValue := PasToZero('I need a parameter')		
		END;
	
	if not Error then
		BEGIN
		ZeroToPas(params[1]^,junk);
		WITH myCPB do
			BEGIN
			ioNamePtr := @junk;
			ioVRefNum := 0;
			ioDrDirID := 0;
			ioFDirIndex := 0;
			END;
		err := PBGetCatInfo(@myCPB,False);
		if err <> noErr then
			BEGIN
			Error := true;
			returnValue := PasToZero('GetCatInfo failed!');
			END
		ELSE
			CurDirStore^ := myCPB.ioDrDirID;
		END;
	END;
END;	{ SetDirectory }

END.